/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: a_bone.h,v 1.18 2009/01/01 07:46:43 fuyu Exp $
 */

#ifndef _LIBOCHUSHA_A_BONE_H_
#define _LIBOCHUSHA_A_BONE_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include "libochusha/hashtable.h"
#include "libochusha/regexp.h"

#include <zlib.h>


using namespace std;
namespace Ochusha
{

  class Response;

  class ABone
  {
  private:
    bool a_bone_by_name;
    char *a_bone_by_name_pattern;
    Regexp a_bone_by_name_regexp;

    bool a_bone_by_mail;
    char *a_bone_by_mail_pattern;
    Regexp a_bone_by_mail_regexp;

    bool a_bone_by_id;
    char *a_bone_by_id_pattern;
    Regexp a_bone_by_id_regexp;

    bool a_bone_by_content;
    char *a_bone_by_content_pattern;
    Regexp a_bone_by_content_regexp;


  public:
    ABone();
    ~ABone();

    inline bool get_a_bone_by_name() const { return a_bone_by_name; }
    inline void set_a_bone_by_name(bool value) { a_bone_by_name = value; }
    inline const char *get_name_pattern() const
    { return a_bone_by_name_pattern; }
    void set_name_pattern(const char *pattern);
    inline Regexp &get_a_bone_by_name_regexp() { return a_bone_by_name_regexp; }

    inline bool get_a_bone_by_mail() const { return a_bone_by_mail; }
    inline void set_a_bone_by_mail(bool value) { a_bone_by_mail = value; }
    inline const char *get_mail_pattern() const
    { return a_bone_by_mail_pattern; }
    void set_mail_pattern(const char *pattern);
    inline Regexp &get_a_bone_by_mail_regexp() { return a_bone_by_mail_regexp; }

    inline bool get_a_bone_by_id() const { return a_bone_by_id; }
    inline void set_a_bone_by_id(bool value) { a_bone_by_id = value; }
    inline const char *get_id_pattern() const { return a_bone_by_id_pattern; }
    void set_id_pattern(const char *pattern);
    inline Regexp &get_a_bone_by_id_regexp() { return a_bone_by_id_regexp; }

    inline bool get_a_bone_by_content() const { return a_bone_by_content; }
    inline void set_a_bone_by_content(bool value) { a_bone_by_content = value; }
    inline const char *get_content_pattern() const
    { return a_bone_by_content_pattern; }
    void set_content_pattern(const char *pattern);
    inline Regexp &get_a_bone_by_content_regexp()
    { return a_bone_by_content_regexp; }

    bool is_a_boned(const Response &response);

    void read_xml_elements(AttributeTable &attributes);
    void write_xml_elements(gzFile file, const char *indent) const;
  };

}


#endif	/* __cplusplus */

#endif	/* _LIBOCHUSHA_A_BONE_H_ */
