/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: bbs_data_manager.h,v 1.11 2009/01/01 07:46:43 fuyu Exp $
 */

#ifndef _LIBOCHUSHA_BBS_DATA_MANAGER_H_
#define _LIBOCHUSHA_BBS_DATA_MANAGER_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include "libochusha/cache_manager.h"

#include <list>


using namespace std;
namespace Ochusha
{
  class Repository;

  class BBSDataManager : public CacheManager
  {
  public:
    BBSDataManager(Repository &repository);
    ~BBSDataManager();

    char *get_pathname(const char *url) const;
    char *get_pathname(const char *url, char *buf, size_t buf_len) const;
    char *find_file(const char *url) const;
    char *find_file(const char *url, char *buf, size_t buf_len) const;
    char *find_directory(const char *url) const;
    char *find_directory(const char *url, char *buf, size_t buf_len) const;
    int open_file(const char *url, int flags) const;
    bool move_file(const char *filename, const char *url);
    void remove_file(const char *url);

    void enumerate_servers(list<string> &result) const;
  };

}


#endif	/* _cplusplus */

#endif	/* _LIBOCHUSHA_BBS_DATA_MANAGER_H_ */
