/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: cookie_manager.h,v 1.5 2009/01/01 07:46:43 fuyu Exp $
 */

#ifndef _LIBOCHUSHA_COOKIE_MANAGER_H_
#define _LIBOCHUSHA_COOKIE_MANAGER_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include "libochusha/http_cookies.h"
#include "libochusha/lock.h"


using namespace std;
namespace Ochusha
{
  class SQLite3;
  class SQLite3Statement;

  class CookieManager
  {
  private:
    Lock lock;
    SQLite3 *db_handle;

    SQLite3Statement *select_all_cookie;
    SQLite3Statement *select_matched_domain;
    SQLite3Statement *select_matched_cookie;
    SQLite3Statement *insert_new_row;
    SQLite3Statement *update_matched_id;
    SQLite3Statement *delete_matched_id;

    void drop_expired_cookies(bool is_at_exit);
    bool update_cookies_db(HTTPCookies &cookies);


  public:
    CookieManager(const char *db_filename);
    ~CookieManager();

    // HTTP쥹ݥ󥹥إåSet-CookieͤᤷϿ롣
    bool set_cookie(const URI &uri, const char *value);

    // HTTP쥹ݥ󥹥إåSet-Cookie2ͤᤷϿ롣
    bool set_cookie2(const URI &uri, const char *value);

    void delete_all_cookies();

    // uriؤΥꥯȤŬCookieꥯȥإå֤ͤ
    char *prepare_cookie(const URI &uri);


    // ׺ƹ͡ΥꥯȤ˥ޥåCookieϰ̤ʣ¸ߤ롣
    // ȤäƤʤΤ̤Τޤޡ
    const HTTPCookie *lookup_cookie(const URI &uri) const;
    void delete_cookie(const HTTPCookie *cookie);

  };

}


#endif	/* __cplusplus */

#endif	/* _LIBOCHUSHA_COOKIE_MANAGER_H_ */
