/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: regexp.h,v 1.16 2009/01/01 07:46:43 fuyu Exp $
 */

#ifndef _LIBOCHUSHA_REGEXP_H_
#define _LIBOCHUSHA_REGEXP_H_

#ifdef __cplusplus

#include <cstddef>

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#ifndef ONIGURUMA_H
typedef struct re_pattern_buffer regex_t;
typedef struct re_registers OnigRegion;
#endif


using namespace std;
namespace Ochusha
{

  class Regexp
  {
  private:
    regex_t *regexp;
    OnigRegion *region;
    const char *last_match_text;
    bool regexp_available;


  public:
    Regexp(const char *pattern = NULL, const char *encoding = NULL);
    ~Regexp();

    bool compile(const char *pattern, const char *encoding = NULL);
    inline bool is_valid() const { return regexp_available; }
    bool match(const char *text, int len);
    const char *match_begin(int group = 0);
    const char *match_end(int group = 0);
    size_t match_len(int group = 0);
  };

}


#endif	/* __cplusplus */

#endif	/* _LIBOCHUSHA_REGEXP_H_ */
