/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: sax_context.h,v 1.13 2009/01/01 07:46:43 fuyu Exp $
 */

#ifndef _LIBOCHUSHA_SAX_CONTEXT_H_
#define _LIBOCHUSHA_SAX_CONTEXT_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include <libxml/xmlstring.h>

#include <cstddef>


using namespace std;
namespace Ochusha
{

  class SAXContext
  {
  protected:
    virtual void start_element_handler(const char *name,
				       const char **attrs) = 0;
    virtual void end_element_handler(const char *name) = 0;
    virtual void characters_handler(const char *ch, size_t len) = 0;


  public:
    SAXContext() {}
    virtual ~SAXContext() {}

    void parse_xml_file(const char *pathname);


  private:
    static void start_element_func(void *context, const xmlChar *name,
				   const xmlChar **attrs);
    static void end_element_func(void *context, const xmlChar *name);
    static void characters_func(void *context, const xmlChar *ch, int len);
  };

}


#endif	/* __cplusplus */

#endif	/* _LIBOCHUSHA_SAX_CONTEXT_H_ */
