/*
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: arrow_action.h,v 1.4 2009/01/01 07:46:51 fuyu Exp $
 */

#ifndef _LIBOCHUSHAGTK_ARROW_ACTION_H_
#define _LIBOCHUSHAGTK_ARROW_ACTION_H_

#include <gtk/gtk.h>
#include <glib.h>

#ifdef __cplusplus
extern "C" {
#endif


#define OCHUSHA_TYPE_ARROW_ACTION		(ochusha_arrow_action_get_type())
#define OCHUSHA_ARROW_ACTION(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), OCHUSHA_TYPE_ARROW_ACTION, OchushaArrowAction))
#define OCHUSHA_ARROW_ACTION_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), OCHUSHA_TYPE_ARROW_ACTION, OchushaArrowActionClass))
#define OCHUSHA_IS_ARROW_ACTION(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), OCHUSHA_TYPE_ARROW_ACTION))
#define OCHUSHA_IS_ARROW_ACTION_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), OCHUSHA_TYPE_ARROW_ACTION))
#define OCHUSHA_ARROW_ACTION_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), OCHUSHA_TYPE_ARROW_ACTION, OchushaArrowActionClass))


typedef struct _OchushaArrowAction OchushaArrowAction;
typedef struct _OchushaArrowActionClass OchushaArrowActionClass;


struct _OchushaArrowAction
{
  GtkAction parent;

  GtkArrowType arrow_type;
  GtkShadowType shadow_type;

  GList *tool_item_list;
};


struct _OchushaArrowActionClass
{
  GtkActionClass parent_class;
};


GType ochusha_arrow_action_get_type(void) G_GNUC_CONST;
OchushaArrowAction *ochusha_arrow_action_new(const gchar *name,
					     const gchar *label,
					     const gchar *tooltip,
					     GtkArrowType arrow_type,
					     GtkShadowType shadow_type);
void ochusha_arrow_action_set(OchushaArrowAction *action,
			      GtkArrowType arrow_type,
			      GtkShadowType shadow_type);


#ifdef __cplusplus
} // extern "C"
#endif

#endif	/* _LIBOCHUSHAGTK_ARROW_ACTION_H_ */
