/*
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: hypertext_tag_table.h,v 1.8 2009/01/01 07:46:51 fuyu Exp $
 */

#ifndef _LIBOCHUSHAGTK_HYPERTEXT_TAG_TABLE_H_
#define _LIBOCHUSHAGTK_HYPERTEXT_TAG_TABLE_H_

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define OCHUSHA_TYPE_HYPERTEXT_TAG_TABLE		(ochusha_hypertext_tag_table_get_type())
#define OCHUSHA_HYPERTEXT_TAG_TABLE(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), OCHUSHA_TYPE_HYPERTEXT_TAG_TABLE, OchushaHypertextTagTable))
#define OCHUSHA_HYPERTEXT_TAG_TABLE_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), OCHUSHA_TYPE_HYPERTEXT_TAG_TABLE, OchushaHypertextTagTableClass))
#define OCHUSHA_IS_HYPERTEXT_TAG_TABLE(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), OCHUSHA_TYPE_HYPERTEXT_TAG_TABLE))
#define OCHUSHA_IS_HYPERTEXT_TAG_TABLE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), OCHUSHA_TYPE_HYPERTEXT_TAG_TABLE))
#define OCHUSHA_HYPERTEXT_TAG_TABLE_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), OCHUSHA_TYPE_HYPERTEXT_TAG_TABLE, OchushaHypertextTagTableClass))


typedef struct _OchushaHypertextTagTable OchushaHypertextTagTable;
typedef struct _OchushaHypertextTagTableClass OchushaHypertextTagTableClass;


struct _OchushaHypertextTagTable
{
  GtkTextTagTable tag_table;

  GSList *link_tag_list;
};


struct _OchushaHypertextTagTableClass
{
  GtkTextTagTableClass parent_class;
};


GType ochusha_hypertext_tag_table_get_type(void) G_GNUC_CONST;

OchushaHypertextTagTable *ochusha_hypertext_tag_table_new(void);
#define ochusha_hypertext_tag_table_add_tag(table, tag)			\
  gtk_text_tag_table_add(&table->tag_table, tag)
void ochusha_hypertext_tag_table_add_link_tag(OchushaHypertextTagTable *table,
					      GtkTextTag *tag);
void ochusha_hypertext_tag_table_remove_tag(OchushaHypertextTagTable *table,
					    GtkTextTag *tag);
#define ochusha_hypertext_tag_table_lookup_tag(table, name)		\
  gtk_text_tag_table_lookup(&table->tag_table, name)

#define ochusha_hypertext_tag_table_foreach_tag(table, func, data)	\
  gtk_text_tag_table_foreach(&table->tag_table, func, data)
void ochusha_hypertext_tag_table_foreach_link_tag(OchushaHypertextTagTable *table,
						  GtkTextTagTableForeach func,
						  gpointer data);

#define ochusha_hypertext_tag_table_get_size(table)			\
  gtk_text_tag_table_get_size(&table->tag_table)

GtkTextTag *ochusha_hypertext_tag_table_find_link_tag_at_iter(OchushaHypertextTagTable *table,
							      GtkTextIter *iter);

#ifdef __cplusplus
} // extern "C"
#endif

#endif	/* _LIBOCHUSHAGTK_HYPERTEXT_TAG_TABLE_H_ */
