/*
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: regex_editor.h,v 1.13 2009/01/01 07:46:51 fuyu Exp $
 */

#ifndef _LIBOCHUSHAGTK_REGEX_EDITOR_H_
#define _LIBOCHUSHAGTK_REGEX_EDITOR_H_

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define OCHUSHA_TYPE_REGEX_EDITOR		(ochusha_regex_editor_get_type())
#define OCHUSHA_REGEX_EDITOR(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), OCHUSHA_TYPE_REGEX_EDITOR, OchushaRegexEditor))
#define OCHUSHA_REGEX_EDITOR_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), OCHUSHA_TYPE_REGEX_EDITOR, OchushaRegexEditorClass))
#define OCHUSHA_IS_REGEX_EDITOR(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), OCHUSHA_TYPE_REGEX_EDITOR))
#define OCHUSHA_IS_REGEX_EDITOR_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), OCHUSHA_TYPE_REGEX_EDITOR))
#define OCHUSHA_REGEX_EDITOR_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), OCHUSHA_TYPE_REGEX_EDITOR, OchushaRegexEditorClass))


typedef struct _OchushaRegexEditor OchushaRegexEditor;
typedef struct _OchushaRegexEditorClass OchushaRegexEditorClass;


struct _OchushaRegexEditor
{
  GtkVBox vbox;

  GtkTextView *regex_view;
  GtkTextBuffer *regex_buffer;
  GtkLabel *message;

  GtkTextTag *error_tag;
};


struct _OchushaRegexEditorClass
{
  GtkVBoxClass parent_class;
};


GType ochusha_regex_editor_get_type(void) G_GNUC_CONST;
GtkWidget *ochusha_regex_editor_new(const gchar *regex_text);
void ochusha_regex_editor_set_regex_text(OchushaRegexEditor *editor,
					 const gchar *text);
void ochusha_regex_editor_append_pattern(OchushaRegexEditor *editor,
					 const gchar *pattern);
void ochusha_regex_editor_append_pattern_escaped(OchushaRegexEditor *editor,
						 const gchar *pattern);
gchar *ochusha_regex_editor_get_regex_text(OchushaRegexEditor *editor);


#ifdef __cplusplus
} // extern "C"
#endif

#endif	/* _LIBOCHUSHAGTK_REGEX_EDITOR_H_ */
