/*
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: response_editor.h,v 1.16 2009/01/01 07:46:51 fuyu Exp $
 */

#ifndef _LIBOCHUSHAGTK_RESPONSE_EDITOR_H_
#define _LIBOCHUSHAGTK_RESPONSE_EDITOR_H_

#include <gtk/gtk.h>

#ifdef __cplusplus
extern "C" {
#endif

#define OCHUSHA_TYPE_RESPONSE_EDITOR		(ochusha_response_editor_get_type())
#define OCHUSHA_RESPONSE_EDITOR(obj)		(G_TYPE_CHECK_INSTANCE_CAST((obj), OCHUSHA_TYPE_RESPONSE_EDITOR, OchushaResponseEditor))
#define OCHUSHA_RESPONSE_EDITOR_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), OCHUSHA_TYPE_RESPONSE_EDITOR, OchushaResponseEditorClass))
#define OCHUSHA_IS_RESPONSE_EDITOR(obj)		(G_TYPE_CHECK_INSTANCE_TYPE((obj), OCHUSHA_TYPE_RESPONSE_EDITOR))
#define OCHUSHA_IS_RESPONSE_EDITOR_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE(klass), OCHUSHA_TYPE_RESPONSE_EDITOR)
#define OCHUSHA_RESPONSE_EDITOR_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS((obj), OCHUSHA_TYPE_RESPONSE_EDITOR, OchushaResponseEditorClass))


typedef struct _OchushaResponseEditor OchushaResponseEditor;
typedef struct _OchushaResponseEditorClass OchushaResponseEditorClass;


struct _OchushaResponseEditor
{
  GtkVBox container;

  /* containerȤtitle_hboxname_mail_hboxtext_view */
  GtkBox *title_hbox;
  GtkBox *name_mail_hbox;

  /* title_hboxȤtitle_entryȤդ٥ */
  GtkEntry *title_entry;

  /* hboxȤname_combomail_comboȤդ٥ȥܥ */
  GtkComboBox *name_combo;
  GtkComboBox *mail_combo;
  GtkToggleButton *show_aa_helper;

  /* AAϻٱ */
  GtkBox *aa_hbox;		/* containerκǲʤ */
  GtkComboBox *aa_combo;
  gint number_of_aa;

  GtkTextView *text_view;

  GList *name_list;
  GList *mail_list;

  guint aa_support : 1;
};


struct _OchushaResponseEditorClass
{
  GtkVBoxClass parent_class;
};


GType ochusha_response_editor_get_type(void) G_GNUC_CONST;

GtkWidget *ochusha_response_editor_new(void);

void ochusha_response_editor_show_title_entry(OchushaResponseEditor *editor);
void ochusha_response_editor_hide_title_entry(OchushaResponseEditor *editor);

const gchar *ochusha_response_editor_get_title(OchushaResponseEditor *editor);
void ochusha_response_editor_set_title(OchushaResponseEditor *editor,
				       const gchar *title);

const gchar *ochusha_response_editor_get_name(OchushaResponseEditor *editor);
void ochusha_response_editor_set_name(OchushaResponseEditor *editor,
				      const gchar *name);
void ochusha_response_editor_add_name(OchushaResponseEditor *editor,
				      const gchar *name);

const gchar *ochusha_response_editor_get_mail(OchushaResponseEditor *editor);
void ochusha_response_editor_set_mail(OchushaResponseEditor *editor,
				      const gchar *mail);
void ochusha_response_editor_add_mail(OchushaResponseEditor *editor,
				      const gchar *name);

void ochusha_response_editor_clear_response(OchushaResponseEditor *editor);
gchar *ochusha_response_editor_get_response(OchushaResponseEditor *editor);
void ochusha_response_editor_append_response(OchushaResponseEditor *editor,
					     const gchar *response);
void ochusha_response_editor_insert_response(OchushaResponseEditor *editor,
					     const gchar *response);
void ochusha_response_editor_set_response(OchushaResponseEditor *editor,
					  const gchar *response);

void ochusha_response_editor_set_aa_support(OchushaResponseEditor *editor,
					    gboolean enable);
gboolean ochusha_response_editor_get_aa_support(OchushaResponseEditor *editor);
void ochusha_response_editor_reset_aa_list(OchushaResponseEditor *editor);
void ochusha_response_editor_add_aa(OchushaResponseEditor *editor,
				    const gchar *aa);
gchar *ochusha_response_editor_get_current_aa(OchushaResponseEditor *editor);


#ifdef __cplusplus
} // extern "C"
#endif

#endif	/* _LIBOCHUSHAGTK_RESPONSE_EDITOR_H_ */
