/*
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: searchable_private.h,v 1.9 2009/01/01 07:46:51 fuyu Exp $
 */

#ifndef _LIBOCHUSHAGTK_SEARCHABLE_PRIVATE_H_
#define _LIBOCHUSHAGTK_SEARCHABLE_PRIVATE_H_

#include "libochushagtk/searchable.h"
#include <glib-object.h>

#include <oniguruma.h>

#ifdef __cplusplus
extern "C" {
#endif


/* äƤΤϡoniguruma¸ä뤿ᡣ */
struct _OchushaSearchKey
{
  GObject parent_object;

  gchar *key_string;
  size_t key_len;

  regex_t *regexp;
  OnigRegion *region;

  const gchar *last_match_pos;	/* ޥåʸƬ */
  size_t last_match_len;	/* ޥåʸĹ */

  guint key_id;			/* 郎Ѥ뤿Ӥ */

  guint regexp_available	: 1;

  guint direction		: 1;
  guint match_case		: 1;
  guint use_regexp		: 1;
};


struct _OchushaSearchKeyClass
{
  GObjectClass parent_class;

  void (*key_changed)(OchushaSearchKey *key, guint key_id);
};


#ifdef __cplusplus
} // extern "C"
#endif

#endif	/* _LIBOCHUSHAGTK_SEARCHABLE_PRIVATE_H_ */
