/*
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: stock.h,v 1.18 2009/01/01 07:46:51 fuyu Exp $
 */

#ifndef _LIBOCHUSHAGTK_STOCK_H_
#define _LIBOCHUSHAGTK_STOCK_H_

#ifdef __cplusplus
extern "C" {
#endif

#define OCHUSHA_STOCK_AA_HELPER_DISABLED	"ochusha-aa-helper-disabled"
#define OCHUSHA_STOCK_AA_HELPER_ENABLED		"ochusha-aa-helper-enabled"
#define OCHUSHA_STOCK_ACTIVE_FOLDER		"ochusha-active-folder"
#define OCHUSHA_STOCK_ADD_BOARD			"ochusha-add-board"
#define OCHUSHA_STOCK_ADD_BOOKMARK		"ochusha-add-bookmark"
#define OCHUSHA_STOCK_BOARD			"ochusha-board"
#define OCHUSHA_STOCK_BOARD_BOOKMARK		"ochusha-board-bookmark"
#define OCHUSHA_STOCK_BOOKMARK			"ochusha-bookmark"
#define OCHUSHA_STOCK_BOOKMARK_FOLDER		"ochusha-bookmark-folder"
#define OCHUSHA_STOCK_EDIT_DISABLED		"ochusha-edit-disabled"
#define OCHUSHA_STOCK_EDIT_ENABLED		"ochusha-edit-enabled"
#define OCHUSHA_STOCK_EMBEDED_EDITOR		"ochusha-embeded-editor"
#define OCHUSHA_STOCK_FOLDER_CLOSED		"ochusha-folder-closed"
#define OCHUSHA_STOCK_FOLDER_OPEN		"ochusha-folder-open"
#define OCHUSHA_STOCK_MISSING_IMAGE		"ochusha-missing-image"
#define OCHUSHA_STOCK_POST			"ochusha-post"
#define OCHUSHA_STOCK_PSEUDO_FOLDER		"ochusha-pseudo-folder"
#define OCHUSHA_STOCK_THREAD			"ochusha-thread"
#define OCHUSHA_STOCK_THREAD_BOOKMARK		"ochusha-thread-bookmark"

#define OCHUSHA_NUMBER_OF_NET_PROGRESS_ADDONS	8
#define OCHUSHA_STOCK_NET_PROGRESS_ADDON0	"ochusha-net-progress-addon-0"
#define OCHUSHA_STOCK_NET_PROGRESS_ADDON1	"ochusha-net-progress-addon-1"
#define OCHUSHA_STOCK_NET_PROGRESS_ADDON2	"ochusha-net-progress-addon-2"
#define OCHUSHA_STOCK_NET_PROGRESS_ADDON3	"ochusha-net-progress-addon-3"
#define OCHUSHA_STOCK_NET_PROGRESS_ADDON4	"ochusha-net-progress-addon-4"
#define OCHUSHA_STOCK_NET_PROGRESS_ADDON5	"ochusha-net-progress-addon-5"
#define OCHUSHA_STOCK_NET_PROGRESS_ADDON6	"ochusha-net-progress-addon-6"
#define OCHUSHA_STOCK_NET_PROGRESS_ADDON7	"ochusha-net-progress-addon-7"
#define OCHUSHA_STOCK_NET_PREPARATION_ADDON	"ochusha-net-preparation-addon"
#define OCHUSHA_STOCK_NET_DONE_ADDON		"ochusha-net-done-addon"
#define OCHUSHA_STOCK_NET_NOTICE_ADDON		"ochusha-net-notice-addon"
#define OCHUSHA_STOCK_NET_ERROR_ADDON		"ochusha-net-error-addon"
#define OCHUSHA_STOCK_NET_WAIT_ADDON		"ochusha-net-wait-addon"


void ochusha_initialize_stock_items(void);


#ifdef __cplusplus
} // extern "C"
#endif

#endif	/* _LIBOCHUSHAGTK_STOCK_H_ */
