/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*- */
/* GdkPixbuf library - Simple frame-based animations
 *
 * Copyright (C) 2004 Dom Lachowicz
 *
 * Authors: Dom Lachowicz <cinamod@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

/*
 * This is a modified version of GdkPixbufSimpleAnim from GTK+-2.10.6 by
 * the Ochusha Project.  See the AUTHORS file for a list of people on the
 * Ochusha Project.  See the ChangeLog files for a list of changes.
 * These files are distributed with ochusha at
 * http://ochusha.sourceforge.jp/.
 *
 * Since libochushagtk_lgpl only has limited set of modified widgets and
 * is intended to be used with the original GTK+, I don't want to cause name
 * space conflictions with original widget sets from GTK+.  Therefore,
 * ALL PUBLICLY AVAILABLE NAMES ARE RENAMED.
 *
 * $Id: mod_pixbuf_simple_anim.h,v 1.1 2006/12/22 01:57:37 fuyu Exp $
 */

#ifndef __MOD_PIXBUF_SIMPLE_ANIM_H__
#define __MOD_PIXBUF_SIMPLE_ANIM_H__


#include <gtk/gtk.h>


G_BEGIN_DECLS

typedef struct _ModPixbufSimpleAnim ModPixbufSimpleAnim;
typedef struct _ModPixbufSimpleAnimClass ModPixbufSimpleAnimClass;

#define MOD_TYPE_PIXBUF_SIMPLE_ANIM              (mod_pixbuf_simple_anim_get_type ())
#define MOD_PIXBUF_SIMPLE_ANIM(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), MOD_TYPE_PIXBUF_SIMPLE_ANIM, ModPixbufSimpleAnim))
#define MOD_IS_PIXBUF_SIMPLE_ANIM(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), MOD_TYPE_PIXBUF_SIMPLE_ANIM))

#define MOD_PIXBUF_SIMPLE_ANIM_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), MOD_TYPE_PIXBUF_SIMPLE_ANIM, ModPixbufSimpleAnimClass))
#define MOD_IS_PIXBUF_SIMPLE_ANIM_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), MOD_TYPE_PIXBUF_SIMPLE_ANIM))
#define MOD_PIXBUF_SIMPLE_ANIM_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), MOD_TYPE_PIXBUF_SIMPLE_ANIM, ModPixbufSimpleAnimClass))


GType mod_pixbuf_simple_anim_get_type (void) G_GNUC_CONST;

ModPixbufSimpleAnim *mod_pixbuf_simple_anim_new           (gint   width, 
                                                           gint   height,
                                                           gfloat rate);
void                 mod_pixbuf_simple_anim_add_frame     (ModPixbufSimpleAnim *animation,
                                                           GdkPixbuf           *pixbuf);
void                 mod_pixbuf_simple_anim_set_loop      (ModPixbufSimpleAnim *animation,
                                                           gboolean value);
gboolean             mod_pixbuf_simple_anim_get_loop      (ModPixbufSimpleAnim *animation);


G_END_DECLS


#endif  /* __MOD_PIXBUF_SIMPLE_ANIM_H__ */
