/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: composite_icon.h,v 1.5 2009/01/01 07:47:06 fuyu Exp $
 */

#ifndef _COMPOSITE_ICON_H_
#define _COMPOSITE_ICON_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include "libochushagtk/stock.h"

#include <gtk/gtk.h>


using namespace std;
namespace Ochusha
{

  class NetworkStateIconSet;

  class CompositeIcon
  {
  private:
    gchar *stock_id;
    NetworkStateIconSet *icon_set;

    static void style_set_cb(GtkWidget *widget, GtkStyle *previous_style,
			     CompositeIcon *icon);
    static void destroy(CompositeIcon *icon);


  public:
    // : Υ֥ȤwidgetȰϡ
    CompositeIcon(GtkWidget *widget, const gchar *stock_id,
		  GtkIconSize size);
    ~CompositeIcon();

    inline const gchar *get_stock_id() const { return stock_id; }

    GdkPixbufAnimation *get_wait_animation() const;
    GdkPixbufAnimation *get_preparation_animation() const;
    GdkPixbufAnimation *get_progress_animation() const;
    GdkPixbuf *get_done_icon() const;
    GdkPixbuf *get_error_icon() const;
    GdkPixbuf *get_notice_icon() const;

    static CompositeIcon *get_composite_icon(GtkWidget *widget);
  };


}


#endif	/* __cplusplus */

#endif	/* _COMPOSITE_ICON_H_ */
