/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: console.h,v 1.12 2009/01/01 07:47:06 fuyu Exp $
 */

#ifndef _CONSOLE_H_
#define _CONSOLE_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include <gtk/gtk.h>

#include <cstdio>


using namespace std;
namespace Ochusha
{


  class Controller;

  class Console
  {
  private:
    Controller &controller;

    char *title;
    int fd;
    gint poll_id;
    GString *string_buffer;

    GtkWidget *dialog;
    GtkTextBuffer *buffer;
    GtkTextIter tail_iter;
    GtkTextView *view;
    GtkTextMark *tail_mark;

    GtkToggleAction *action;

    static gboolean poll_cb(GIOChannel *channel, GIOCondition condition,
			    Console *console);
    static void response_cb(GtkWidget *widget, int id, Console *console);
 
    void prepare_dialog();


  public:
    Console(Controller &controller,
	    const char *title, int fd = -1, GtkToggleAction *action = NULL);
    ~Console();

    void show();
    void output(const char *message);
    void clear();

    void prepare_shutdown();
  };


}


#endif	/* __cplusplus */

#endif	/* _CONSOLE_H_ */
