/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: fonts_ui.h,v 1.10 2009/01/01 07:47:06 fuyu Exp $
 */

#ifndef _FONTS_UI_H_
#define _FONTS_UI_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include "libochusha/sigslot.h"

#include <gtk/gtk.h>


using namespace std;
namespace Ochusha
{
  class Controller;
  class Preferences;

  class FontsUI : public has_slots
  {
  private:
    Controller &controller;

    GtkWidget *tree_view_font_selection_dialog;
    GtkWidget *thread_view_font_selection_dialog;


    // sigslotʥϥɥ
    void prefs_changed_cb(Preferences &prefs);


    void write_prefs_gtkrc(const gchar *tree_view_font_name);
    void reload_prefs_gtkrc();

    gchar *get_current_tree_view_font();

    GtkWidget *setup_tree_view_font_selection_dialog();
    static void tree_view_font_selection_dialog_response_cb(GtkWidget *dialog,
							    int response_id,
							    FontsUI *ui);

    GtkWidget *setup_thread_view_font_selection_dialog();
    static void thread_view_font_selection_dialog_response_cb(GtkWidget *dialog,
							      int response_id,
							      FontsUI *ui);


  public:
    FontsUI(Controller &controller);
    ~FontsUI();

    void show_tree_view_font_selection_dialog();
    void show_thread_view_font_selection_dialog();

    void prepare_shutdown();
  };


}


#endif	/* __cplusplus */

#endif	/* _FONTS_UI_H_ */
