/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: histories_ui.cc,v 1.3 2009/01/01 07:47:06 fuyu Exp $
 */

#include "config.h"

#include "libochusha/ochusha_intl.h"

#if defined(__GNUG__) && !defined(__ICC)
#pragma implementation
#endif
#include "histories_ui.h"

#include "libochusha/history_manager.h"

#include "controller.h"
#include "session_client.h"
#include "tree_view.h"

#include "libochushagtk/stock.h"

#include <cassert>

#include <gtk/gtk.h>


namespace Ochusha
{


HistoryEntry::HistoryEntry(const char *name, const char *url, time_t tc,
			   time_t last_mod)
  : TreeElement(name, tc, last_mod),
    history(NULL)
{
}


HistoryEntry::HistoryEntry(History &history, time_t tc, time_t last_mod)
  : TreeElement(NULL, tc, last_mod),
    history(NULL)
{
}


HistoryEntry::~HistoryEntry()
{
  if (history != NULL)
    delete history;
}


bool
HistoryEntry::is_folder() const
{
  return false;
}


const char *
HistoryEntry::get_element_name() const
{
  return "entry";
}


void
HistoryEntry::read_extended_tree_element(AttributeTable &attributes)
{
  // ȤʤϤ
}


void
HistoryEntry::write_extended_tree_element(WriteTree &args)
{
  // ȤʤϤ
}


HistoriesRoot::HistoriesRoot()
  : RootFolder("Histories")
{
}


Folder *
HistoriesRoot::folder_new(time_t tc, time_t last_mod, unsigned int sn)
{
  return new Folder(FOLDER_TYPE_PSEUDO_FOLDER, NULL, tc, last_mod, sn);
}


Folder *
HistoriesRoot::folder_new(const Folder *folder, unsigned int sn)
{
  return new Folder(folder, sn);
}


TreeElement *
HistoriesRoot::leaf_element_new(AttributeTable &attributes,
				time_t tc, time_t last_mod)
{
  // ȤʤϤġġ
  return new HistoryEntry(NULL, NULL, tc, last_mod);
}


TreeElement *
HistoriesRoot::copy(const TreeElement *element)
{
  // ȤʤϤ
  return NULL;
}


bool
HistoriesRoot::read_histories(Repository &repository)
{
  return false;
}


bool
HistoriesRoot::write_histories(Repository &repository)
{
  return false;
}


const char *
HistoriesRoot::get_root_element_name() const
{
  return "histories";
}


const char *
HistoriesRoot::get_leaf_element_name() const
{
  return "entry";
}


}
