/*
 * Copyright (c) 2003-2007 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: html40_css.inc,v 1.4 2008/12/14 09:05:49 fuyu Exp $
 */

#ifndef _HTML40_CSS_INC_
#define _HTML40_CSS_INC_

static const char default_style_sheet_html40[] =
  "html, address,\n"
  "blockquote,\n"
  "body, dd, div,\n"
  "dl, dt, fieldset, form,\n"
  "frame, frameset,\n"
  "h1, h2, h3, h4,\n"
  "h5, h6, noframes,\n"
  "ol, p, ul, center,\n"
  "dir, hr, menu, pre   { display: block }\n"
  "li              { display: list-item }\n"
  "head            { display: none }\n"
  "table           { display: table }\n"
  "tr              { display: table-row }\n"
  "thead           { display: table-header-group }\n"
  "tbody           { display: table-row-group }\n"
  "tfoot           { display: table-footer-group }\n"
  "col             { display: table-column }\n"
  "colgroup        { display: table-column-group }\n"
  "td, th          { display: table-cell }\n"
  "caption         { display: table-caption }\n"
  "th              { font-weight: bolder; text-align: center }\n"
  "caption         { text-align: center }\n"
  "body            { margin: 8px }\n"
  "h1              { font-size: 2em; margin: .67em 0 }\n"
  "h2              { font-size: 1.5em; margin: .75em 0 }\n"
  "h3              { font-size: 1.17em; margin: .83em 0 }\n"
  "h4, p,\n"
  "blockquote, ul,\n"
  "fieldset, form,\n"
  "ol, dl, dir,\n"
  "menu            { margin: 1.12em 0 }\n"
  "h5              { font-size: .83em; margin: 1.5em 0 }\n"
  "h6              { font-size: .75em; margin: 1.67em 0 }\n"
  "h1, h2, h3, h4,\n"
  "h5, h6, b,\n"
  "strong          { font-weight: bolder }\n"
  "blockquote      { margin-left: 40px; margin-right: 40px }\n"
  "i, cite, em,\n"
  "var, address    { font-style: italic }\n"
  "pre, tt, code,\n"
  "kbd, samp       { font-family: monospace }\n"
  "pre             { white-space: pre }\n"
  "button, textarea,\n"
  "input, select   { display: inline-block }\n"
  "big             { font-size: 1.17em }\n"
  "small, sub, sup { font-size: .83em }\n"
  "sub             { vertical-align: sub }\n"
  "sup             { vertical-align: super }\n"
  "table           { border-spacing: 2px; }\n"
  "thead, tbody,\n"
  "tfoot           { vertical-align: middle }\n"
  "td, th          { vertical-align: inherit }\n"
  "s, strike, del  { text-decoration: line-through }\n"
  "hr              { border: 1px inset }\n"
  "ol, ul, dir,\n"
  "menu, dd        { margin-left: 40px }\n"
  "ol              { list-style-type: decimal }\n"
  "ol ul, ul ol,\n"
  "ul ul, ol ol    { margin-top: 0; margin-bottom: 0 }\n"
  "u, ins          { text-decoration: underline }\n"
  "br:before       { content: \"\\A\" }\n"
  ":before, :after { white-space: pre-line }\n"
  "center          { text-align: center }\n"
  ":link, :visited { text-decoration: underline }\n"
  ":focus          { outline: thin dotted invert }\n"
  "\n"
  "/* Begin bidirectionality settings (do not change) */\n"
  "BDO[DIR=\"ltr\"]  { direction: ltr; unicode-bidi: bidi-override }\n"
  "BDO[DIR=\"rtl\"]  { direction: rtl; unicode-bidi: bidi-override }\n"
  "\n"
  "*[DIR=\"ltr\"]    { direction: ltr; unicode-bidi: embed }\n"
  "*[DIR=\"rtl\"]    { direction: rtl; unicode-bidi: embed }\n"
  "\n"
  "@media print {\n"
  "h1            { page-break-before: always }\n"
  "h1, h2, h3,\n"
  "h4, h5, h6    { page-break-after: avoid }\n"
  "ul, ol, dl    { page-break-before: avoid }\n"
  "}\n";

#endif	/* _HTML40_CSS_INC_ */
