/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: link_ui.h,v 1.6 2009/01/01 07:47:07 fuyu Exp $
 */

#ifndef _LINK_UI_H_
#define _LINK_UI_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include <gtk/gtk.h>


using namespace std;
namespace Ochusha
{

  class Controller;

  class LinkUI
  {
    friend class ThreadlistView;
    friend class TreeView;
    friend class BBSThreadViewBase;

  private:
    Controller &controller;

    GtkActionGroup *action_group;

    // Хǥ󥰴ϢǻȤͽ
    GtkAction *open_link_location;
    GtkAction *open_link_location_in_tab;
    GtkAction *open_link_location_with_web_browser;
    GtkAction *bookmark_link_location;
    GtkAction *copy_link_location;


    GtkActionGroup *create_action_group();

    static void owner_change_cb(GtkClipboard *clipboard, GdkEvent *event,
				LinkUI *ui);


    // Ϣ
    static void open_link_location_cb(GtkAction *action, LinkUI *ui);
    static void open_link_location_in_tab_cb(GtkAction *action, LinkUI *ui);
    static void open_link_location_with_web_browser_cb(GtkAction *action,
						       LinkUI *ui);
    static void copy_link_location_cb(GtkAction *action, LinkUI *ui);
    static void bookmark_link_location_cb(GtkAction *action, LinkUI *ui);


  public:
    LinkUI(Controller &controller);
    ~LinkUI();
  };


}


#endif	/* __cplusplus */

#endif	/* _LINK_UI_H_ */
