static const char default_init_scm[] =
";;\n"
";; This file is just same as embeded one loaded by default and\n"
";; must be encoded in UTF-8.\n"
";;\n"
";; If user have a file \"~/.ochusha/ochusha-init.scm\", the file will be\n"
";; loaded instead of the default one.\n"
";;\n"
";; $Id: ochusha-init-default.scm,v 1.1 2009/01/05 12:18:03 fuyu Exp $\n"
";;\n"
"\n"
";; Descriptions below can be seen as examples.\n"
"\n"
";; The ochusha defines a set of constants to represent `color's and\n"
";; use especially for coloring threadlists.  These constants actually are\n"
";; `reference's to the `color's that can be changed by users through\n"
";; Preferences dialog of the ochusha.\n"
";;                                                THE DEFAULT DEFINITION\n"
";; `list-entry-fg-normal', `list-entry-bg-normal' GTK+/GNOME theme's default\n"
";; `list-entry-fg-emph', `list-entry-bg-emph'     theme's default, lavender\n"
";; `list-entry-fg-strong', `list-entry-bg-strong' red, theme's default\n"
";; `list-entry-fg-hidden', `list-entry-bg-hidden' gray75, theme's default\n"
";;\n"
";; By default, the ochusha paints threadlists like below using these constants.\n"
";;\n"
";; Hidden Threads\n"
";;   => (list-entry-fg-hidden . list-entry-bg-hidden)\n"
";; Threads DAT dropped\n"
";;   => (list-entry-fg-normal . list-entry-bg-strong)\n"
";; New threads\n"
";;   => (list-entry-fg-emph . list-entry-bg-emph)\n"
";; Threads you read and exists unread responses\n"
";;   => (list-entry-fg-strong . list-entry-bg-strong)\n"
";; The other threads\n"
";;   => (list-entry-fg-normal . list-entry-bg-normal) can be abbreved by '()\n"
"\n"
";; The COLOR object can be defined at Scheme procedure level using\n"
";; `gdk-color-parse' procedure like below.\n"
";; The `gdk-color-parse' procedure calls the C function `gdk_color_parse()',\n"
";; and thus you can refer common color names defined in\n"
";; \"/usr/X11R6/lib/X11/rgb.txt\" or \"/usr/share/X11/rgb.txt\"\n"
";; or specify RGB value like \"#RRGGBB\".  When error occurred during\n"
";; color definition, default values will be refered.\n"
";(define test-fg (gdk-color-parse \"yellow\"))\n"
"\n"
"\n"
";; This is the default algorithm to paint threadlists.\n"
"(define (decorate-list-entry-default thread)\n"
"  (let ((new-responses (thread-get-number-of-new-responses thread))\n"
"	(n-got (thread-get-number-of-responses-got thread)))\n"
"    (cond ((thread-hidden? thread)\n"
"	   (cons list-entry-fg-hidden list-entry-bg-hidden))\n"
"	  ((not (thread-alive? thread))\n"
"	   (cons list-entry-fg-normal list-entry-bg-strong))\n"
"	  ((> n-got 0)\n"
"	   (if (> (thread-get-number-of-responses-on-server thread) n-got)\n"
"	       (cons list-entry-fg-strong list-entry-bg-strong) '()))\n"
"	  ((thread-new? thread)\n"
"	   (cons list-entry-fg-normal list-entry-bg-emph))\n"
"	  (else '()))))\n"
"\n"
"\n"
";; The ochusha calls the Scheme procedure named `decorate-list-entry'\n"
";; to see how to decorate threadlists and each rows of threadlists\n"
";; are painted according to the `pair' returned by `decorate-list-entry'\n"
";; procedure.\n"
";;\n"
";; (car (decorate-list-entry thread)) is used to specify the foreground color\n"
";; (cdr (decorate-list-entry thread)) is used to specify the background color\n"
";;\n"
";; The ochusha paints rows using GTK+/GNOME theme's default when\n"
";; `decorate-list-entry' returns '().\n"
"(define decorate-list-entry decorate-list-entry-default)\n"
"\n"
"\n"
";; The `interest-thread?\" procedure determines whether the given thread\n"
";; is interesting one, i.e. to be read by user, or not.\n"
";; This procedure is used especially by threadlists' action bound only\n"
";; to key-presses such as 'p', 'n' and 'Space'.\n"
"(define (interest-thread? thread)\n"
"  (and (> (thread-get-number-of-responses-got thread) 0)\n"
"       (> (thread-get-number-of-responses-to-read thread) 0)))\n"
"\n"
"\n"
";; The `register-threadlist-rule' procedure registers a rule for\n"
";; sorting and filtering of threadlists.\n"
";; (register-threadlist-rule NAME LABEL DESCRIPTION PROCEDURE)\n"
";;\n"
";; NAME is an identifier STRING.  If there's already a rule having\n"
";; the same NAME registered, the older one will be replaced by the new one.\n"
";;\n"
";; LABEL is a STRING will be shown in GUI components like menus.\n"
";;\n"
";; DESCRIPTION is a STRING explains the rule.\n"
";;\n"
";; PROCEDURE is a scheme procedure that implements the rule.  Rows of\n"
";; Threadlist will be sorted in ascending order of value returned by\n"
";; this PROCEDURE and threads that are calculated as #f by this\n"
";; PROCEDURE will be hidden from threadlists.  The PROCEDURE must\n"
";; be of a scheme procedure that takes exacly one argument of\n"
";; THREAD object.\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-all\"\n"
" (_ \"All\")\n"
" (_ \"Threads alive->threads DAT dropped\")\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread) 0 10000)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-live-only\"\n"
" (_ \"Live threads\")\n"
" (_ \"All threads alive\")\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread) 0 #f)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-dead-only\"\n"
" (_ \"Dead threads\")\n"
" (_ \"All threads DAT dropped\")\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread) #f 0)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-all-newer-to-older\"\n"
" (_ \"All newer to older\")\n"
" (_ \"All threads in the order of newer to older\")\n"
" (lambda (thread)\n"
"   (- #x7fffffff (thread-get-birthtime thread))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-plain-all-older-to-newer\"\n"
" (_ \"All older to newer\")\n"
" (_ \"All threads in the order of older to newer\")\n"
" (lambda (thread)\n"
"   (thread-get-birthtime thread)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-importance-order\"\n"
" (_ \"All prioritized\")\n"
" (_ \"Read(with unread)->New->Read(w/o unread)->Live->Dead\")\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (+ (if (thread-hidden? thread) 10000 0)\n"
"	(if (thread-marked? thread) 0 5000)\n"
"	(if (> n-got 0)\n"
"	    (if (> n-res n-got) 0 2000)\n"
"	    (if (thread-new? thread) 1000 3000))\n"
"	(if (thread-alive? thread) 0 5000)))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-important-only\"\n"
" (_ \"Threads in interest\")\n"
" (_ \"Read(with unread)->New->Read(w/o unread)->Read(Dead)\")\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (if (and (= n-got 0) (not (thread-marked? thread)))\n"
"	 #f\n"
"	 (+ (if (thread-marked? thread) 0 5000)\n"
"	    (if (> n-got 0)\n"
"		(if (> n-res n-got) 0 2000)\n"
"		(if (thread-new? thread) 1000 3000))\n"
"	    (if (thread-alive? thread) 0 5000))))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-important-unread-only\"\n"
" (_ \"Unread in interest\")\n"
" (_ \"Threads read having unread responses\")\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (if (or (= n-got 0) (<= n-res n-got))\n"
"	 #f\n"
"	 (+ (if (thread-marked? thread) 0 5000)\n"
"	    (if (thread-alive? thread) 0 5000))))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-important-live-only\"\n"
" (_ \"Live in interest\")\n"
" (_ \"Threads read(with unread)->Threads read(w/o unread)\")\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (if (or (and (= n-got 0)\n"
"		  (not (thread-marked? thread)))\n"
"	     (not (thread-alive? thread)))\n"
"	 #f\n"
"	 (+ (if (thread-marked? thread) 0 5000)\n"
"	    (if (> n-got 0)\n"
"		(if (> n-res n-got) 0 2000)))))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-importance-order-live-only\"\n"
" (_ \"Live prioritized\")\n"
" (_ \"Read(with unread)->New->Read(w/o unread)->Other live threads\")\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (if (thread-alive? thread)\n"
"	 (+ (if (thread-hidden? thread) 10000 0)\n"
"	    (if (thread-marked? thread) 0 5000)\n"
"	    (if (> n-got 0)\n"
"		(if (> n-res n-got) 0 2000)\n"
"		(if (thread-new? thread) 1000 3000)))\n"
"	 #f))))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-live-only-newer-to-older\"\n"
" (_ \"Live newer to older\")\n"
" (_ \"All threads alive in the order of newer to older\")\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread)\n"
"       (- #x7fffffff (thread-get-birthtime thread)) #f)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-live-only-older-to-newer\"\n"
" (_ \"Live older to newer\")\n"
" (_ \"All threads alive in the order of older to newer\")\n"
" (lambda (thread)\n"
"   (if (thread-alive? thread)\n"
"       (thread-get-birthtime thread) #f)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-mark-only\"\n"
" (_ \"Marked\")\n"
" (_ \"Threads have marked\")\n"
" (lambda (thread)\n"
"   (if (thread-marked? thread) 0 #f)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-only-mark-is-important\"\n"
" (_ \"All marked to unmarked\")\n"
" (_ \"Marked threads->other threads\")\n"
" (lambda (thread)\n"
"   (if (thread-marked? thread) 0 1000)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-marked-unread-is-important\"\n"
" (_ \"All marked unread first\")\n"
" (_ \"Marked(with unread)->Marked(w/o unread)->Live->Dead\")\n"
" (lambda (thread)\n"
"   (if (thread-marked? thread)\n"
"       (if (> (thread-get-number-of-responses-on-server thread)\n"
"	      (thread-get-number-of-responses-read thread))\n"
"	   0 1000)\n"
"       2000)))\n"
"\n"
"\n"
"(register-threadlist-rule\n"
" \"ochusha-default-importance-order-mark-first\"\n"
" (_ \"All prioritized with mark\")\n"
" (_ \"Marked->Read(with unread)->New->Read(w/o unread)->Live->Dead\")\n"
" (lambda (thread)\n"
"   (let ((n-res (thread-get-number-of-responses-on-server thread))\n"
"	 (n-got (thread-get-number-of-responses-read thread)))\n"
"     (+ (if (thread-hidden? thread) 10000 0)\n"
"	(if (thread-marked? thread) 0 20000)\n"
"	(if (> n-got 0)\n"
"	    (if (> n-res n-got) 0 2000)\n"
"	    (if (thread-new? thread) 1000 3000))\n"
"	(if (thread-alive? thread) 0 5000)))))\n"
"\n"
"\n"
";; (register-external-tool NAME LABEL DESCRIPTION TOOL-TYPE TEMPLorPROC)\n"
";;\n"
";; NAME is an identifier STRING.  If there's already a tool having\n"
";; the same NAME registered, the older one will be replaced by the new one.\n"
";;\n"
";; LABEL is a STRING will be shown in GUI components like menus.\n"
";;\n"
";; DESCRIPTION is a STRING explains the tool.\n"
";;\n"
";; TOOL-TYPE specify the category of the tool.  This is a SYMBOL specifies\n"
";; which menu should be include the tool in effect.\n"
";; There's three types reserved in the ochusha as like below:\n"
";;\n"
";; 'link-tool	specifies the tool is for URLs.\n"
";; 'image-tool	specifies the tool is for cached image files.\n"
";; 'text-tool	specifies the tool is for selected texts.\n"
";;\n"
";; TEMPLorPROC is either a STRING that represents a commandline template\n"
";; or a PROCEDURE that generates a commandline template based on the argument,\n"
";; URL STRING or the pathname STRING of the target.\n"
";; The substring \"%ARG%\" within template will be replaced by the URL, the\n"
";; pathname or texts being selected as the target object of the tool.\n"
";; When template contains \"%FILENAME_FROM_ARG%\" or \"%FILENAME%\" as\n"
";; a substring, a filechooser dialog will be shown before execution of\n"
";; commandline and those substrings will be replaced by the user's file\n"
";; selection.  The only differences between \"%FILENAME_FROM_ARG%\" and\n"
";; \"%FILENAME%\" is the initial filename setting of filechooser dialog.\n"
"(register-external-tool\n"
" \"save-image\"\n"
" \"Save Image As ...\"\n"
" \"Save Image As ...\"\n"
" 'image-tool\n"
" \"cp %ARG% %FILENAME_FROM_ARG%\")\n"
"\n"
";; In this example, a procedure that expands the STRING argument as\n"
";; the pathname of commandline is registered as TEMPLorPROC.\n"
"(register-external-tool\n"
" \"browse-image-with-eog\"\n"
" (_ \"Eye of GNOME\")\n"
" (_ \"Open image with Eye of GNOME(eog)\")\n"
" 'image-tool\n"
" (lambda (filename)\n"
"   (format \"eog ~a\" filename)))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"browse-image-with-gimp\"\n"
" (_ \"Gimp\")\n"
" (_ \"Open Image with gimp\")\n"
" 'image-tool\n"
" \"gimp-remote %ARG%\")\n"
"\n"
"\n"
"(register-external-tool\n"
" \"download-url-with-wget\"\n"
" (_ \"Wget\")\n"
" (_ \"Open URL with Wget\")\n"
" 'link-tool\n"
" \"xterm -e wget %ARG%\")\n"
"\n"
"\n"
"(register-external-tool\n"
" \"open-url-with-d4x\"\n"
" (_ \"d4x\")\n"
" (_ \"Open URL with d4x\")\n"
" 'link-tool\n"
" (lambda (url)\n"
"   (format \"d4x ~a\" url)))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"search-archive-with-web-browser\"\n"
" (_ \"Internet Archive Wayback Machine\")\n"
" (_ \"Search URL at Internet Archive Wayback Machine\")\n"
" 'link-tool\n"
" (lambda (url)\n"
"   (format \"%WEBBROWSER% http://web.archive.org/*/~a\" url)))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"google-text-in-japanese\"\n"
" (_ \"Google Search(Japanese Pages)\")\n"
" (_ \"Search text at Google for Japanese pages\")\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.google.co.jp/search?hl=ja&q=~a&btnG=Google+%E6%A4%9C%E7%B4%A2&lr=lang_ja\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"google-text-in-all\"\n"
" (_ \"Google Search(Entire Web)\")\n"
" (_ \"Search text at google for entire web pages\")\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.google.co.jp/search?hl=ja&q=~a&btnG=Google+%E6%A4%9C%E7%B4%A2&lr=\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"google-image\"\n"
" (_ \"Google Search(Images)\")\n"
" (_ \"Search text at google for images\")\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.google.co.jp/images?hl=ja&q=~a&btnG=Google+%E3%82%A4%E3%83%A1%E3%83%BC%E3%82%B8%E6%A4%9C%E7%B4%A2&lr=\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"excite-english-japanese-dictionary\"\n"
" (_ \"excite dictionaries(English-Japanese)\")\n"
" (_ \"Lookup text in excite English-Japanese dictionary\")\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.excite.co.jp/dictionary/english_japanese/?search=~a&submit=+%E6%A4%9C+%E7%B4%A2+&match=beginswith&dictionary=NEW_EJJE\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"excite-japanese-english-dictionary\"\n"
" (_ \"excite dictionaries(Japanese-English)\")\n"
" (_ \"Lookup text in excite Japanese-English dictionary\")\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://www.excite.co.jp/dictionary/japanese_english/?search=~a&submit=+%E6%A4%9C+%E7%B4%A2+&match=beginswith\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"wikipedia-ja-search\"\n"
" (_ \"Wikipedia(ja)\")\n"
" (_ \"Search text in Wikipedia(ja)\")\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://ja.wikipedia.org/wiki/%E7%89%B9%E5%88%A5:Search?search=~a&fulltext=%E6%A4%9C%E7%B4%A2\" (url-encode-string text))))\n"
"\n"
"\n"
"(register-external-tool\n"
" \"wikipedia-en-search\"\n"
" (_ \"Wikipedia(english)\")\n"
" (_ \"Search text in Wikipedia(english)\")\n"
" 'text-tool\n"
" (lambda (text)\n"
"   (format \"%WEBBROWSER% http://en.wikipedia.org/wiki/Special:Search?search=~a&fulltext=Search\" (url-encode-string text))))\n"
"\n"
"\n"
"\n"
";; Reserved procedure to rewrite URLs.\n"
"(define (rewrite-link-default link) link)\n"
"\n"
";; The ochusha will call `rewrite-link' procedure to rewrite URLs.\n"
";; Not used at the time being.\n"
"(define rewrite-link rewrite-link-default)\n"
"\n"
"\n"
"\n"
";; Retrieves STRING from output-string-port and close the port.\n"
"(define (close-string-port string-port)\n"
"  (let ((result (get-output-string string-port)))\n"
"    (close-output-port string-port)\n"
"    result))\n"
"\n"
"\n"
"\n"
";; The implementation of GtkToolbar hides GtkComboBox if there's enough\n"
";; space to show the entire GtkComboBox with in a toolbar.  This behavior\n"
";; isn't good for user's experience, we add an ad-hoc work-around to\n"
";; limit the length of `thread-title' shown on GtkComboBox.\n"
";; If you have the ochusha window wide enough to show all thread title\n"
";; as they are, this doesn't make sense.\n"
";;\n"
";; In the future, we will allow users to specify the parameter of\n"
";; abbreviation of thread-title, e.g. number of characters, and/or\n"
";; the algorithm to abbreviate the thread-title through GUI but\n"
";; it is hard-coded at this time.\n"
"\n"
";; This procedure abbriviates thread-title simply by cutting STRING\n"
";; according to the reduced number of so-called half-width characters.\n"
"(define (abbreviate-thread-title-by-heading n thread-title)\n"
"  (letrec ((char-width (lambda (char-string)\n"
"			 (if (eq? (string-length char-string) 1) 1 2)))\n"
"	   (append-chars\n"
"	    (lambda (string-port rest-len splitted-title)\n"
"	      (if (null? splitted-title) string-port\n"
"		  (let* ((next-char (car splitted-title))\n"
"			 (next-char-width (char-width next-char)))\n"
"		    (if (< rest-len next-char-width) string-port\n"
"			(begin\n"
"			  (display next-char string-port)\n"
"			  (append-chars string-port\n"
"					(- rest-len next-char-width)\n"
"					(cdr splitted-title)))))))))\n"
"    (close-string-port (append-chars\n"
"			(open-output-string)\n"
"			n\n"
"			(regexp-split #// thread-title)))))\n"
"\n"
"\n"
";; Although it is clear that contents of STRING has more effects for\n"
";; effective width of GUI representation than the differences between\n"
";; so-called half-width characters and full-width characters if propotional\n"
";; fonts are used, we don't try to see the contents because it is\n"
";; almost impossible to calculate the pixel-size of contents.\n"
";; The effective pixel-size of a STRING within GUI can only be calculated\n"
";; by letting GTK+ show the STRING in the very context ;-<.\n"
";;\n"
";; If you uncomment this, thread-title will be abbreviated by heading\n"
";; 44 characters.\n"
";(define (abbreviate-thread-title thread-title)\n"
";  (abbreviate-thread-title-by-heading 44 thread-title))\n"
"\n"
"\n"
";; We don't abbreviate thread-title by default.\n"
"(define (abbreviate-thread-title thread-title) thread-title)\n"
"\n"
"\n"
"(define (caadddr x) (car (cadddr x)))\n"
"(define (cdadddr x) (cdr (cadddr x)))\n"
"\n"
"\n"
";; This procedure rewrites messages of each responses as like below:\n"
";; - substrings seem to be URLs will be rewritten as `a' elements of HTML.\n"
";; - substrings that aren't treated as `anchor of responses' will be\n"
";;   rewritten as response anchor if appropriate, e.g. >NUMBER.\n"
"(define (rewrite-message-default message)\n"
"  (letrec\n"
"      ((rewrite-additional-response-number\n"
"	(lambda (message output)\n"
"	  (let* ((match-pos\n"
"		  (regexp-match-positions #/^(?:[ ,､、，=＝]+)([0-9０-９]+)/\n"
"					  message))\n"
"		 (match-beg (if match-pos (caar match-pos) 0))\n"
"		 (match-end (if match-pos (cdar match-pos) 0))\n"
"		 (number-beg (if match-pos (caadr match-pos) 0))\n"
"		 (number-end (if match-pos (cdadr match-pos) 0)))\n"
"	    (if match-pos\n"
"		(begin (output \"<a href=\\\"\")\n"
"		       (output (substring message number-beg number-end))\n"
"		       (output \"\\\">\")\n"
"		       (output (substring message match-beg match-end))\n"
"		       (output \"</a>\")\n"
"		       (rewrite-additional-response-number\n"
"			(substring message match-end) output))\n"
"		(rewrite-message message output)))))\n"
"       (rewrite-non-link-response-number\n"
"	(lambda (message output)\n"
"	  (let* ((match-pos\n"
"		  (regexp-match-positions\n"
"		   #/(?:&gt;|[＞≫〉》])+([0-9０-９]+[-―ー─－〜]?[0-9０-９]*)/\n"
"		   message))\n"
"		 (match-beg (if match-pos (caar match-pos) 0))\n"
"		 (match-end (if match-pos (cdar match-pos) 0))\n"
"		 (numbers-beg (if match-pos (caadr match-pos) 0))\n"
"		 (numbers-end (if match-pos (cdadr match-pos) 0)))\n"
"	    (if match-pos\n"
"		(begin (output (substring message 0 match-beg))\n"
"		       (output \"<a href=\\\"\")\n"
"		       (output (substring message numbers-beg numbers-end))\n"
"		       (output \"\\\">\")\n"
"		       (output (substring message match-beg match-end))\n"
"		       (output \"</a>\")\n"
"		       (rewrite-additional-response-number\n"
"			(substring message match-end) output))\n"
"		(output message)))))\n"
"       (rewrite-non-link-url\n"
"	(lambda (message output)\n"
"	  (let* ((match-pos\n"
"		  (regexp-match-positions\n"
"		   #/(h?[ft]?)tp(s?):\\/\\/([0-9a-zA-Z\\/#?;:@&%=+\\-!*$,._~'()]+)/\n"
"		   message))\n"
"		 (match-beg0 (if match-pos (caar match-pos) 0))\n"
"		 (match-end0 (if match-pos (cdar match-pos) 0))\n"
"		 (match-beg1 (if match-pos (caadr match-pos) 0))\n"
"		 (match-end1 (if match-pos (cdadr match-pos) 0))\n"
"		 (match-beg2 (if match-pos (caaddr match-pos) 0))\n"
"		 (match-end2 (if match-pos (cdaddr match-pos) 0))\n"
"		 (match-beg3 (if match-pos (caadddr match-pos) 0))\n"
"		 (match-end3 (if match-pos (cdadddr match-pos) 0)))\n"
"	    (if match-pos\n"
"		(begin (rewrite-non-link-response-number\n"
"			(substring message 0 match-beg0) output)\n"
"		       (output \"<a href=\\\"\")\n"
"		       (if (eqv? (substring message match-beg1 match-end1) \"f\")\n"
"			   (output \"f\")\n"
"			   (output \"ht\"))\n"
"		       (output \"tp\")\n"
"		       (output (substring message match-beg2 match-end2))\n"
"		       (output \"://\")\n"
"		       (output (substring message match-beg3 match-end3))\n"
"		       (output \"\\\">\")\n"
"		       (output (substring message match-beg0 match-end0))\n"
"		       (output \"</a>\")\n"
"		       (rewrite-non-link-url\n"
"			(substring message match-end0) output))\n"
"		(rewrite-non-link-response-number message output)))))\n"
"       (rewrite-message\n"
"	(lambda (message output)\n"
"	  (let ((match-pos (regexp-match-positions\n"
"			    #/<[aA][[:space:]][^>]+>[^<]*<\\/a>/ message)))\n"
"	    (if match-pos\n"
"		(begin (rewrite-non-link-url\n"
"			(substring message 0 (caar match-pos)) output)\n"
"		       (output (substring\n"
"				message (caar match-pos) (cdar match-pos)))\n"
"		       (rewrite-additional-response-number\n"
"			(substring message (cdar match-pos)) output))\n"
"		(rewrite-non-link-url message output))))))\n"
"    (let ((result-port (open-output-string)))\n"
"      (rewrite-message message (lambda (text) (display text result-port)))\n"
"      (close-string-port result-port))))\n"
"\n"
"\n"
"\n"
";; The ochusha calls the Scheme procedure named `rewrite-message' for\n"
";; each responses during rendering of threads' view.\n"
"(define rewrite-message rewrite-message-default)\n"
"\n"
"\n"
"\n"
";; The ochusha calls the Scheme procedure named `image-link?' to determine\n"
";; an URL is for image or not.\n"
"(define (image-link? url) #f)\n"
"\n"
"\n"
";; The ochusha calls the Scheme procedure named `rewrite-image-link'\n"
";; to allow users to manipulate URLs for images before networking.\n"
";; The result of this procedure must be an URL STRING or a PAIR of\n"
";; (URL . REFERER).  Other values let the ochusha use URLs as they are.\n"
";; If a PAIR of (URL . REFERER) is returned, the ochusha accesses\n"
";; returned URL instead of the url given as the argument of this\n"
";; procedure and sets the REFERER as the value of Referer HTTP\n"
";; request header.\n"
"(define (rewrite-image-link url) #f)\n"
"\n"
"\n"
";; The ochusha calls the Scheme procedure named `redirect-image-link'\n"
";; to look for the actual image URL if access result for image URL\n"
";; returns a HTML text as successful access, i.e. status-code 200.\n"
";; When this procedure returns a URL STRING, the ochusha will try\n"
";; to download images from returned URL like HTTP redirection.\n"
";; The argument `url' gives the URL as STRING that is used for\n"
";; networking.  The argument `page-source' gives the HTML text as\n"
";; STRING that is the resulting body of HTTP GET for `url'.\n"
"(define (redirect-image-link url page-source) #f)\n"
;
