/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: threadlist_ui.h,v 1.14 2009/01/01 07:47:07 fuyu Exp $
 */

#ifndef _THREADLIST_UI_H_
#define _THREADLIST_UI_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include <gtk/gtk.h>


using namespace std;
namespace Ochusha
{
  class BBSThread;
  class Controller;
  class ThreadlistView;

  class ThreadlistUI
  {
    friend class ThreadlistView;

  private:
    Controller &controller;
    GtkActionGroup *action_group;

    // Хǥ󥰴ϢǻȤͽ
    GtkAction *open_trackback_with_web_browser;
    GtkAction *mark_thread;
    GtkAction *unmark_thread;
    GtkAction *hide_thread;
    GtkAction *toggle_hide_thread;
    GtkAction *reset_thread;
    GtkAction *copy_url;
    GtkAction *copy_title;
    GtkAction *copy_title_url;
    GtkAction *properties;


    GtkActionGroup *create_action_group();

    static void owner_change_cb(GtkClipboard *clipboard, GdkEvent *event,
				ThreadlistUI *ui);


    // ݥåץåץ˥塼Ϣ
    static void open_trackback_with_web_browser_cb(GtkAction *action,
						   ThreadlistUI *ui);
    static void mark_thread_cb(GtkAction *action, ThreadlistUI *ui);
    static void unmark_thread_cb(GtkAction *action, ThreadlistUI *ui);
    static void hide_thread_cb(GtkAction *action, ThreadlistUI *ui);
    static void toggle_hide_thread_cb(GtkAction *action, ThreadlistUI *ui);
    static void reset_thread_cb(GtkAction *action, ThreadlistUI *ui);
    static void copy_url_cb(GtkAction *action, ThreadlistUI *ui);
    static void copy_title_cb(GtkAction *action, ThreadlistUI *ui);
    static void copy_title_url_cb(GtkAction *action, ThreadlistUI *ui);
    static void properties_cb(GtkAction *action, ThreadlistUI *ui);

    static void tree_selection_open_trackback_with_web_browser(
							GtkTreeModel *model,
							GtkTreePath *path,
							GtkTreeIter *iter,
							gpointer data);
    static void tree_selection_mark(GtkTreeModel *model, GtkTreePath *path,
				    GtkTreeIter *iter, gpointer data);
    static void tree_selection_unmark(GtkTreeModel *model, GtkTreePath *path,
				      GtkTreeIter *iter, gpointer data);
    static void tree_selection_hide(GtkTreeModel *model, GtkTreePath *path,
				    GtkTreeIter *iter, gpointer data);
    static void tree_selection_toggle_hide(GtkTreeModel *model,
					   GtkTreePath *path,
					   GtkTreeIter *iter, gpointer data);
    static void tree_selection_reset(GtkTreeModel *model, GtkTreePath *path,
				     GtkTreeIter *iter, gpointer data);
    static void tree_selection_copy_url(GtkTreeModel *model, GtkTreePath *path,
					GtkTreeIter *iter, gpointer data);
    static void tree_selection_copy_title(GtkTreeModel *model,
					  GtkTreePath *path,
					  GtkTreeIter *iter, gpointer data);
    static void tree_selection_copy_title_url(GtkTreeModel *model,
					      GtkTreePath *path,
					      GtkTreeIter *iter, gpointer data);
    static void tree_selection_properties(GtkTreeModel *model,
					  GtkTreePath *path,
					  GtkTreeIter *iter, gpointer data);


  public:
    ThreadlistUI(Controller &controller);
    ~ThreadlistUI();

    void open_properties(BBSThread *thread);
    void prepare_session();
  };


}


#endif	/* __cplusplus */

#endif	/* _THREADLIST_UI_H_ */
