/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: ui_constants.h,v 1.36 2010/08/15 15:42:20 fuyu Exp $
 */

#ifndef _UI_CONSTANTS_H_
#define _UI_CONSTANTS_H_


#define OCHUSHA_HOME_URL			"http://ochusha.sourceforge.jp"

#ifndef OCHUSHA_HELP_URL
#define OCHUSHA_HELP_URL			OCHUSHA_HOME_URL "/help/"
#endif


#define OCHUSHA_ANARCHY_GTKRC			"ochusha-anarchy-gtkrc"
#define OCHUSHA_GTKRC				"ochusha-gtkrc"
#define OCHUSHA_PREFS_GTKRC			"ochusha-prefs-gtkrc"

#define OCHUSHA_INIT_SCM			"ochusha-init.scm"

#define OCHUSHA_SESSION_XML			"session.xml.gz"
#define OCHUSHA_UI_XML				"ochusha-ui.xml"
#define OCHUSHA_ACCEL_MAP_RC			"ochusha-accel-map.rc"

#define OCHUSHA_PREFS_XML			"prefs.xml.gz"

#define OCHUSHA_PREFS_CSS			"ochusha-prefs.css"
#define OCHUSHA_USER_CSS			"ochusha-user.css"

#define OCHUSHA_AALIST_TXT			"aalist.txt"

#define OCHUSHA_A_BONE_IMAGES_SQLITE		"a-bone-images.sqlite"
#define OCHUSHA_IMAGE_ACCESSES_SQLITE		"image-accesses.sqlite"


#define CONFIG_VERSION_OCHUSHA_0_6		6


// mainåɡpollingåɰʳѤ륹åɤο
// å夵줿եɤ߹ߤΤ˰ĻȤ롣
// ͥåȥBufferΥåcontentionΤϵʤΤǡ
// ¼ŪDNSѤ˶ᤤ
#define INITIAL_NUM_WORKER_THREADS		3
#define MAXIMUM_NUM_WORKER_THREADS		6


// Ʊɤݸ̵ߤԤΤǡ¤롣
#define MAXIMUM_NUM_IMAGE_DOWNLOADERS		4


// ɽϥݥåץåפĤ塢Ūˤϻäå
// Ƥ㤨Сݥ󥿤󥯤˽ФäꤷơƱ
// ݥåץåפνФ줬ˤ˵äꡢĤ줬˳ľ
// ꤷˡǥΥåե뤫κɤ߹ߤǤ롣
#define IMAGE_CACHE_TIMEOUT			10000	// 10


// mmap(2)ǤʤĶǤϲΥåեread(2)ɤ߹ࡣ
// λѤ֥ХåեΥ
#define LOAD_IMAGE_CHUNKSIZE			262144	// 256KB


// Υͥåȥ˰Ūʥ顼ǼԤ硢
// ʲô֤Ʊ꥽ؤΥ򼫽ͤ롣
#define IMAGE_LOADER_VOLUNTARY_INTERVAL		900	// 15ʬ


// TreeUIδGtkTreeViewrowǱå˥ݥåץå
// ˥塼ФΤ٤餻֡¨˥ݥåץåץ˥塼Ф
// åǥɥåϤǤʤ
// ȤäƤ⡢åɥåϥɥå׻˥ݥåץåץ˥塼
// ФȤ񤤤Τݤ
#define POPUP_MENU_DELAY_TIMEOUT		250	// ms


// ֥åޡɲûʤɤɽκǶῨäե
// ꥹ(GtkComboBox)Ǥο
#define NUMBER_OF_RECENT_FOLDERS		5


// ɾʤɲǽʸ¤ǿξ¸ΤˤĤơŪ
// ¸ɬǧѹäΤ¸Ԥֳ֡
// Ǥthreadlist.xmlboardlist.xmlbookmarks.xmlǤȤä
// prefs.xmlʤɤˤб롣
#define PERIODIC_SAVE_TIMEOUT			2000	// 2000ms == 2


#define DEFAULT_WEB_BROWSER_TEMPLATE		"xdg-open %s"

#define DEFAULT_SHOW_NAVIGATION_TOOLBAR		FALSE
#define DEFAULT_SHOW_THREADLIST_TOOLBAR		TRUE
#define DEFAULT_SHOW_THREAD_TOOLBAR		TRUE
#define DEFAULT_SHOW_BOARDLIST_TOOLBAR		FALSE
#define DEFAULT_SHOW_BOOKMARKS_TOOLBAR		FALSE

#define DEFAULT_SHOW_BOARDLIST_SIDEBAR		TRUE
#define DEFAULT_SHOW_BOOKMARKS_SIDEBAR		TRUE
#define DEFAULT_SHOW_HISTORY_SIDEBAR		FALSE
#define DEFAULT_SHOW_POST_HISTORY_SIDEBAR	FALSE

#define DEFAULT_SHOW_HIDDEN_BOARDLIST_ITEMS	FALSE
#define DEFAULT_SHOW_HIDDEN_THREADS		FALSE

#define DEFAULT_VERTICAL_PLACEMENT		TRUE
#define DEFAULT_DEFAULT_OPEN_IN_TAB		FALSE
#define DEFAULT_SELECT_TAB_WHEN_OPENED		FALSE
#define DEFAULT_FOCUS_FOLLOW_MOUSE		FALSE
#define DEFAULT_FOCUS_FOLLOW_MOUSE_MODESTLY	TRUE

#define DEFAULT_EMBEDED_RESPONSE_EDITOR		FALSE
#define DEFAULT_PREFER_EMBEDED_RESPONSE_EDITOR	FALSE

#define DEFAULT_BOARD_TAB_SHRINKABLE		TRUE
#define DEFAULT_BOARD_TAB_MINIMUM_SIZE		80
#define DEFAULT_BOARD_TAB_ENABLE_TOOLTIPS	FALSE
#define DEFAULT_BOARD_TAB_ALWAYS_SHOW		FALSE
#define DEFAULT_BOARD_PANE_ALWAYS_SHOW		FALSE

#define DEFAULT_THREADLIST_VIEW_CONTENTS	"RMTvuBL"
#define DEFAULT_DEFAULT_THREADLIST_RULE		"ochusha-default-plain-all"

#define DEFAULT_THREAD_TAB_SHRINKABLE		TRUE
#define DEFAULT_THREAD_TAB_MINIMUM_SIZE		80
#define DEFAULT_THREAD_TAB_ENABLE_TOOLTIPS	FALSE
#define DEFAULT_THREAD_TAB_ALWAYS_SHOW		FALSE
#define DEFAULT_THREAD_PANE_ALWAYS_SHOW		FALSE

#define DEFAULT_ENABLE_TRANSPARENT_A_BONE	FALSE
#define DEFAULT_DISABLE_POPUP_A_BONE		FALSE
#define DEFAULT_DISABLE_A_BONE			FALSE
#define DEFAULT_ENABLE_CHAIN_A_BONE		FALSE
#define DEFAULT_SHOW_MAILTO			FALSE

#define DEFAULT_INITIAL_VIEW_POSITION_ACTIVE	MY_BOOKMARK
#define DEFAULT_INITIAL_VIEW_POSITION_INACTIVE	LAST_VIEW_POSITION

#define DEFAULT_HIDE_MY_BOOKMARK		FALSE

#define DEFAULT_ENABLE_POPUP_TITLE		FALSE
#define DEFAULT_ENABLE_POPUP_RESPONSE		TRUE
#define DEFAULT_ENABLE_POPUP_ID			FALSE

#define DEFAULT_ENABLE_BE_ICON			TRUE
#define DEFAULT_ENABLE_INLINE_IMAGE		FALSE
#define DEFAULT_ENABLE_POPUP_IMAGE		FALSE
#define DEFAULT_DOWNLOAD_SHOWN_IMAGES_ONLY	FALSE

#define DEFAULT_POPUP_DELAY			500
#define DEFAULT_POPDOWN_DELAY			100
#define DEFAULT_MAX_NUM_OF_POPUP_RESPONSES	5

#define DEFAULT_INLINE_IMAGE_WIDTH		160
#define DEFAULT_INLINE_IMAGE_HEIGHT		120
#define DEFAULT_POPUP_IMAGE_WIDTH		480
#define DEFAULT_POPUP_IMAGE_HEIGHT		360

#define DEFAULT_CAPACITY_OF_IMAGE_CACHE		256
#define DEFAULT_MAX_NUM_OF_IMAGE_CACHE_FILES	1024

#define DEFAULT_LOGIN_2CH_BE_AT_STARTUP		FALSE
#define DEFAULT_SAVE_2CH_BE_PASSWD		FALSE
#define DEFAULT_LOGIN_2CH_VIEWER_AT_STARTUP	FALSE
#define DEFAULT_SAVE_2CH_VIEWER_PASSWD		FALSE

#define DEFAULT_RESTORE_OPENED_TABS		FALSE

#define DEFAULT_FG_NORMAL_COLOR			""
#define DEFAULT_BG_NORMAL_COLOR			""
#define DEFAULT_FG_EMPH_COLOR			""
#define DEFAULT_BG_EMPH_COLOR			"#ffe0e0"
#define DEFAULT_FG_STRONG_COLOR			"red"
#define DEFAULT_BG_STRONG_COLOR			"lavender"
#define DEFAULT_FG_HIDDEN_COLOR			"gray75"
#define DEFAULT_BG_HIDDEN_COLOR			""
#define DEFAULT_AUTO_REFRESH_GO_COLOR		"forestgreen"
#define DEFAULT_AUTO_REFRESH_WAIT_COLOR		"red"
#define DEFAULT_THREAD_TITLE_COLOR		"red"
#define DEFAULT_NAME_COLOR			"forestgreen"
#define DEFAULT_LINK_COLOR			"blue"
#define DEFAULT_VISITED_COLOR			"purple"


#define MAXIMUM_NUMBER_OF_RECENT_NAME_LIST_ENTRIES		10
#define MAXIMUM_NUMBER_OF_RECENT_MAIL_LIST_ENTRIES		10


#ifdef __cplusplus


// ü
extern Ochusha::Monitor ochusha_gdk_threads_lock;
#define OCHUSHA_GDK_THREADS_LOCK()	(&ochusha_gdk_threads_lock)


bool ochusha_gdk_threads_tryenter();
#define OCHUSHA_GDK_THREADS_TRYENTER()	(ochusha_gdk_threads_tryenter())


// ǥХå
bool ochusha_in_gdk_threads();
#define OCHUSHA_IN_GDK_THREADS()	(ochusha_in_gdk_threads())

#endif	/* __cplusplus */


#endif	/* _UI_CONSTANTS_H_ */
