/* -*- c++ -*-
 * Copyright (c) 2003-2009 The Ochusha Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: xsmp_handler.h,v 1.12 2009/01/01 07:47:07 fuyu Exp $
 */

#ifndef _XSMP_HANDLER_H_
#define _XSMP_HANDLER_H_

#ifdef __cplusplus

#if defined(__GNUG__) && !defined(__ICC)
#pragma interface
#endif

#include <glib.h>


using namespace std;
namespace Ochusha
{
  class XSMPHandlerPrivate;

  class XSMPHandler
  {
  private:
    friend class XSMPHandlerPrivate;
    XSMPHandlerPrivate *priv;

    char *sm_client_id;
    char *previous_sm_client_id;

    gboolean sm_disable;
    gchar *discard_session;

    int argc;
    char **argv;


  public:
    XSMPHandler();
    virtual ~XSMPHandler();

    GOptionGroup *get_option_group();

    // --discardץäfalse֤ξץϽλ٤
    bool process_command_line();
    bool open_session(int argc, char **argv);
    void close_session();

    const char *get_sm_client_id() { return sm_client_id; }


  protected:
    virtual void save_yourself(const char *smc_id) = 0;
    virtual void die(const char *smc_id) = 0;
    virtual void save_complete(const char *smc_id) = 0;
    virtual void shutdown_cancelled(const char *smc_id) = 0;


    // process_command_line()η̤Ȥ
    // ꥹȤ줿åξsmc_idϥޥɥ饤ǻꤵ줿
    // åξsmc_idNULLǸƤӽФ롣
    virtual void restore(const char *smc_id) = 0;
    virtual void discard(const char *smc_id) = 0;
  };


}


#endif	/* __cplusplus */

#endif	/* _XSMP_HANDLER_H_ */
